//***************************
//******memory registers*****
//***************************
//look up
void Lookup_DMA
{
	RDRAM_memory,	RDRAM_register,	SP_register	,	DP_register,	MI_register,
	VI_register	,	AI_register	  , PI_register	,	RI_register,	RI_register,
	SI_register	,	Rom_Image	  , PIF_boot_ROM,	PIF_RAM
}
//rdram memory
char * RDRAM1; malloc (RDRAM1[0x00000000]);
char * RDRAM0; malloc (RDRAM0[0x00200000]);

//rdram register

int * RDRAM_BASE_REG; RDRAM_BASE_REG = 0x03F00000;

char * RDRAM_CONFIG_REG; malloc (RDRAM_CONFIG_REG[0x03F00000]);
char * RDRAM_DEVICE_ID_REG; malloc (RDRAM_DEVICE_ID_REG[0x03F00004]);
char * RDRAM_DELAY_REG; malloc (RDRAM_DELAY_REG[0x03F00008]);
char * RDRAM_MODE_REG; malloc (RDRAM_MODE_REG[0x03F0000C]);
char * RDRAM_REF_INTERVAL_REG; malloc (RDRAM_REF_INTERVAL_REG[0x03F00010]);
char * RDRAM_REF_ROW_REG; malloc (RDRAM_REF_ROW_REG[0x03F00014]);
char * RDRAM_RAS_INTERVAL_REG; malloc (RDRAM_RAS_INTERVAL_REG[0x03F00018]);
char * RDRAM_MIN_INTERVAL_REG; malloc (RDRAM_MIN_INTERVAL_REG[0x03F0001C]);
char * RDRAM_ADDR_SELECT_REG; malloc (RDRAM_ADDR_SELECT_REG[0x03F00020]);
char * RDRAM_DEVICE_MANUF_REG; malloc (RDRAM_DEVICE_MANUF_REG[0x03F00024]);

// SP register
int * SP_BASE_REG; SP_BASE_REG = 0x04040000;

char * SP_DMEM; malloc (SP_DMEM[0x04000000]);
char * SP_IMEM; malloc (SP_IMEM[0x04001000]);
char * SP_MEM_ADDR_REG; malloc (SP_MEM_ADDR_REG[0x04040000]);
char * SP_DRAM_ADDR_REG; malloc (SP_DRAM_ADDR_REG[0x04040004]);
char * SP_RD_LEN_REG; malloc (SP_RD_LEN_REG[0x04040008]);
char * SP_WR_LEN_REG; malloc (SP_WR_LEN_REG[0x0404000C]);
char * SP_STATUS_REG; malloc (SP_STATUS_REG[0x04040010]);
char * SP_DMA_FULL_REG; malloc (SP_DMA_FULL_REG[0x04040017]);
char * SP_DMA_BUSY_REG; malloc (SP_DMA_BUSY_REG[0x04040018]);
char * SP_SEMAPHORE_REG; malloc (SP_SEMAPHORE[0x0404001C]);
char * SP_PC_REG; malloc (SP_PC_REG[0x04080000]);
char * SP_IBIST_REG; malloc (SP_IBIST_REG[0x04080004]);

// DPC register
int * DPC_BASE_REG; DPC_BASE_REG = 0x04100000;
char * DPC_START_REG; malloc (DPC_START_REG[0x04100000]);
char * DPC_END_REG; malloc (DPC_END_REG[0x04100004]);
char * DPC_CURRENT_REG; malloc (DPC_CURRENT_REG[0x04100008]);
char * DPC_STATUS_REG; malloc (DPC_STATUS_REG[0x0410000C]);
char * DPC_CLOCK_REG; malloc (DPC_CLOCK_REG[0x04100010]);
char * DPC_BUFBUSY_REG; malloc (DPC_BUFBUSY_REG[0x04100014]);
char * DPC_PIPEBUSY_REG; malloc (DPC_PIPEBUSY_REG[0x04100018]);
char * DPC_TMEM_REG; malloc (DPC_TMEM_REG[0x04100020]);

// DPS register
int * DPS_BASE_REG; DPS_BASE_REG = 0x04200000;
char * DPS_TBIST_REG; malloc (DPS_TBIST_REG[0x04200000]);
char * DPS_TEST_MODE_REG; malloc (DPS_TEST_MODE_REG[0x04200004]);
char * DPS_BUFTEST_ADDR_REG; malloc (DPS_BUFTEST_DATA_REG[0x0420000C]);

//MIPS registers
int * MI_BASE_REG; MI_BASE_REG = 0x04300000;
char * MI_MODE_REG; malloc (MI_MODE_REG[0x04300000])
char * MI_VERSION_REG; malloc (MI_VERSION_REG[0x04300004]);
char * MI_INTR_REG; malloc (MI_INTR_REG[0x04300008]);
char * MI_INTR_MASK_REG; malloc (MI_INTR_MASK_REG[0x0430000C]);

//VI registers
int VI_BASE_REG; VI_BASE_REG = 0x04400000;
char * VI_STATUS_REG; malloc (VI_STATUS_REG[0x04400000]);
char * VI_ORIGIN_REG; malloc (VI_ORIGIN_REG[0x04400004]);
char * VI_WIDTH_REG; malloc (VI_WIDTH_REG[0x04400008]);
char * VI_INTR_REG; malloc (VI_INTR_REG[0x0440000C]);
char * VI_CURRENT_REG; malloc (VI_CURRENT_REG[0x04400010]);
char * VI_BURST_REG; malloc (VI_BURST_REG[0x04400014]);
char * VI_V_SYNC_REG; malloc (VI_V_SYNC_REG[0x04400018]);
char * VI_H_SYNC_REG; malloc (VI_H_SYNC_REG[0x0440001C]);
char * VI_LEAP_REG; malloc (VI_LEAP_REG[0x04400020]);
char * VI_H_START_REG; malloc (VI_H_START_REG[0x04400024]);
char * VI_V_START_REG; malloc (VI_V_START_REG[0x04400028]);
char * VI_V_BURST_REG; malloc (VI_V_BURST_REG[0x0440002C]);
char * VI_X_SCALE_REG; malloc (VI_X_BURST_REG[0x04400030]);
char * VI_Y_SCALE_REG; malloc (VI_Y_SCALE_REG[0x04400034]);

//AI registers
int AI_BASE_REG; AI_BASE_REG = 0x04500000;
char * AI_DRAM_ADDR_REG; malloc (AI_DRAM_ADDR_REG[0x04500000]);
char * AI_LEN_REG; malloc (AI_LEN_REG[0x04500004]);
char * AI_CONTROL_REG; malloc (AI_CONTROL_REG[0x04500008]);
char * AI_STATUS_REG; malloc (AI_STATUS_REG[0x0450000C]);
char * AI_DACRATE_REG; malloc (AI_DACRATE_REG[0x04500010]);
char * AI_BITRATE_REG; malloc (AI_BITRATE_REG[0x04500014]);

//PI registers
int PI_BASE_REG; AI_BASE_REG = 0x04600000;
char * PI_DRAM_ADDR_REG; malloc (PI_DRAM_ADDR_REG[0x04600000]);
char * PI_CART_ADDR_REG; malloc (PI_CART_ADDR_REG[0x04600004]);
char * PI_RD_LEN_REG; malloc (PI_RD_LEN_REG[0x04600008]);
char * PI_WR_LEN_REG; malloc (PI_WR_LEN_REG[0x0460000C]);
char * PI_STATUS_REG; malloc (PI_STATUS_REG[0x04600010]);
char * PI_DOMAIN1_REG; malloc (PI_DOMAIN1_REG[0x04600014]);
char * PI_DOM1_PWD_REG; malloc (PI_DOM1_PWD_REG[0x04600018]);
char * PI_DOM1_PGS_REG; malloc (PI_DOM1_PGS_REG[0x0460001C]);
char * PI_DOM1_RLS_REG; malloc (PI_DOM1_RLS_REG[0x04600020]);
char * PI_DOMAIN2_REG; malloc (PI_DOMAIN2_REG[0x04600024]);
char * PI_DOM2_PWD_REG; malloc (PI_DOM2_PWD_REG[0x04600028]);
char * PI_DOM2_PGS_REG; malloc (PI_DOM2_PGS_REG[0x0460002C]);
char * PI_DOM2_RLS_REG; malloc (PI_DOM2_RLS_REG[0x04600030]);

//RI registers
int RI_BASE_REG; RI_BASE_REG = 0x04700000;
char * RI_MODE_REG; malloc (RI_MODE_REG[0x04700000]);
char * RI_CONFIG_REG; malloc (RI_CONFIG_REG[0x04700004]);
char * RI_CURRENT_LOAD_REG; malloc (RI_CURRENT_LOAD_REG[0x04700008]);
char * RI_SELECT_REG; malloc (RI_SELECT_REG[0x0470000C]);
char * RI_REFRESH_REG; malloc (RI_REFRESH_REG[0x04700010]);
char * RI_LATENCY_REG; malloc (RI_LATENCY_REG[0x04700014]);
char * RI_RERROR_REG; malloc (RI_RERROR_REG[0x04700018]);
char * RI_WERROR_REG; malloc (RI_WERROR_REG[0x0470001C]);

//SI registers
int SI_BASE_REG; SI_BASE_REG = 0x04800000;
char * SI_DRAM_ADDR_REG; malloc (SI_DRAM_ADDR_REG[0x04800000]);
char * SI_PIF_ADDR_RD64B; malloc (SI_PIF_ADDR_RD64B[0x04800004]);
char * SI_PIF_ADDR_WR64B; malloc (SI_PIF_ADDR_RD64B[0x04800008]);
char * SI_STATUS_REG; malloc (SI_STATUS_REG[0x0480000C]);


//*******************
//*****GPR maps******
//*******************

#define R0 0x00h
#define AT 0x01h
#define V0 0x02h
#define V1 0x03h
#define A0 0x04h
#define A1 0x05h
#define A2 0x06h
#define A3 0x07h
#define T0 0x08h
#define T1 0x09h
#define T2 0x0Ah
#define T3 0x0Bh
#define T4 0x0Ch
#define T5 0x0Dh
#define T6 0x0Eh
#define T7 0x0Fh
#define S0 0x10h
#define S1 0x11h
#define S2 0x12h
#define S3 0x13h
#define S4 0x14h
#define S5 0x15h
#define S6 0x16h
#define S7 0x17h
#define T8 0x18h
#define T9 0x19h
#define K0 0x1Ah
#define K1 0x1Bh
#define GP 0x1Ch
#define SP 0x1Dh
#define S8 0x1Eh
#define RA 0x1Fh
#define INDEX     0x00h
#define RANDOM    0x01h
#define ENTRYLO0  0x02h
#define ENTRYLO1  0x03h
#define CONTEXT   0x04h
#define PAGEMASK  0x05h
#define WIRED     0x06h
#define BADVADDR  0x08h
#define COUNT     0x09h
#define ENTRYHI   0x0Ah
#define COMPARE   0x0Bh
#define STATUS    0x0Ch
#define CAUSE     0x0Dh
#define EPC       0x0Eh
#define PREVID    0x0Fh
#define CONFIG    0x10h
#define LLADDR    0x11h
#define WATCHLO   0x12h
#define WATCHHI   0x13h
#define XCONTEXT  0x14h
#define PERR      0x1Ah
#define CACHEERR  0x1Bh
#define TAGLO     0x1Ch
#define TAGHI     0x1Dh
#define ERROREPC  0x1Eh



