/*------------------------------------------------------------------------
 Module:        C:\BEYOND64\R4300I.C
 Author(s):     J-e-Z, Blitz, DarkReign, Membrane, KeyH, Schleeb, Lahma
 Project:       PC64 + Beyond64 inc.
 State:         This and every other document included is under the laws of GNU
 Creation Date: 15th June 1999
 Description:   R4300i Core, No DYNAREC, NOT YET FINISHED!!, also unsigning and signextending
                required
 Contact:       http://pc64.flood.net || www.emunews.de/beyond64
 Note:          Please who ever is doing the GUI could you include the functions

                File : Load Rom, Load State, Save Rom, Save State, Exit
                Emulation : Start, Stop, Reset, Pause
                Debug : Debugger, WireFrame,
                Video : 320x240, 512x380 640x480, 1024x768 1280x960
                Plug-in(s) : Plug-In(s)
                Controller : Configuration
                Help : Help, About, Plug-in Manual
                                                J-e-Z

 Extras:        I am hoping on making this emulator able to have netplay and a zoomer
                so in multiplayer you dont have to look at everyone elses screen


------------------------------------------------------------------------*/
/* R4300i opcodes */
#include windows.h

_int8* Rom_Image
char DEBUG; DEBUG = OFF; // debug toggle needs to be in GUI as well
char GPR, CCR, COC;

/*
static void LB;
static void LBU;
static void LD;
static void LDL;
static void LDR;
static void LH;
static void LHU;
static void LL;
static void LLD;
static void LW;
static void LWL;
static void LWR;
static void LWU;
static void SB;
static void SC;
static void SCD;
static void SD;
static void SDL;
static void SDR;
static void SH;
static void SW;
static void SWL;
static void SWR;
static void SYNC;
static void ADD;
static void ADDI;
static void ADDIU;
static void ADDU;
static void AND;
static void ANDI;
static void DADD;
static void DADDI;
static void DADDIU;
static void DADDU;
static void DDIV;
static void DDIVU;
static void DIV;
static void DIVU;
static void MULT;
static void MULTU;
static void DSLL;
static void DSLL32;
static void DSLLV;
static void DSRA;
static void DSRA32;
static void DSRAV;
static void DSRL;
static void DSRL32;
static void DSRLV;
static void DSUB;
static void DSUBU;
static void LUI;
static void MFHI;
static void MFLO;
static void MTHI;
static void MTLO;
static void MULT;
static void MULTU;
static void NOR;
static void OR;
static void ORI;
static void SLL;
static void SLLV;
static void SLT;
static void LTI;
static void SLTIU;
static void SLTU;
static void SRA;
static void SRAV;
static void SRL;
static void SRLV;
static void SUB;
static void SUBU;
static void XOR;
static void XORI;
static void BEQ;
static void BEQL;
static void BGEZ;
static void BGEZAL;
static void BGEZALL;
static void BGEZL;
static void BGTZ;
static void BGTZL;
static void BLEZ;
static void BLEZL;
static void BLTZ;
static void BLTZAL;
static void BLTZALL;
static void BLTZL;
static void BNE;
static void BNEL;
static void J;
static void JAL;
static void JALR;
static void JR;
static void BREAK;
static void SYSCALL;
static void TEQ;
static void TEQI;
static void TGE;
static void TGEI;
static void TGEIU;
static void TGEU;
static void TLT;
static void TLTI;
static void TLTIU;
static void TLTU;
static void TNE;
static void TNEI;
static void CACHE;
static void ERET;
static void MFC0;
static void MTC0;
static void TLBP;
static void TLBR;
static void TLBWI;
static void TLBWR;
static void ABS.fmt;
static void ADD.fmt;
static void BC1F;
static void BC1FL;
static void BC1T;
static void BC1TL;
static void C.cond.fmt;
static void CEIL.L.fmt;
static void CFC1;
static void CTC1;
static void CVT.D.fmt;
static void CVT.W.fmt;
static void CVT.S.fmt;
static void CVT.W.fmt;
static void DIV.fmt;
static void DMFC1;
static void DMTC1;
static void FLOOR.L.fmt;
static void FLOOR.W.fmt;
static void LDC1;
static void LWC1;
static void MFC1;
static void MOV.fmt;
static void MTC1;
static void MUL.fmt;
static void NEG.fmt;
static void ROUND.L.fmt;
static void ROUND.W.fmt;
static void SDC1;
static void SQRT.fmt;
static void SUB.fmt;
static void SWC1;
static void TRUNC.L.fmt;
static void TRUNC.W.fmt;
static void NOP;
static void MOVE;
static void NEG;
static void NEGU;
static void BNEZ;
static void BNEZL;
static void BEQZ;
static void BEQZL;
static void B;
static void BAL;
static void LI;
static void S.S;
static void L.S;
*/

void Reset()
{
	CPU = OFF
	// todo reset interrupt registers
	// todo clean all register
}



//*********************
//***R4300i Register***
//*********************
#define RS        ((instruction & 0x03E00000) > 21)
#define RT        ((instruction & 0x001F0000) > 16)
#define RD        ((instruction & 0x0000F800) > 11)
#define SA        ((instruction & 0x000007C0) > 6)
#define BASE      RS
#define OFFSET    IMME
#define IMME      (instruction & 0x0000FFFF)
#define CCR0	  RS
#define CCR1	  RS
#define CCR2      RS

//*********************
//*r4300i instructions*
//******plus loop******
//*********************
char cpu; cpu = OFF;
void main_emu_loop
{
    while( cpu = ON );
	{
		   Check_DMA();

		   Check_keyboard_Status();
		   // check delays
		   if ( delay = 0 );
		   {
			   PC+=4
		   }
		   if ( delay = 1 );
		   {
			   PC+=4
			   delay = 2;
		   }
		   else
		   {
			   PC = PCdelay
			   delay = 0;
		   }

		   check_interrupt(); // to be defined in interrupts.c
		   // opcode finder
		   switch (opcode)
		   {
			  default:
			   	  printf("Error: Unknown Opcode.\n");
				  break;

			  switch (special)
			  {
					  default:
						    printf("Error: Unknown Opcode.\n");
							break;

					  case SLL:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}

					        GPR[RD] = GPR[RT] << SA;
   	            	        break;

					  case SRL:
							if ( DEBUG = ON );
							{
								//todo debugger
							}
							GPR[RD] = GPR[RT] >> SA;
							break;

					  case SRA:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}

   	     					GPR[RD] = (GPR[RT] >> SA);
   	            	        break;

					  case SLLV:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}

					        GPR[RD] = GPR[RT] << SA;
   	            	        break;

					  case SRLV:
							if ( DEBUG = ON );
							{
							    //todo debugger
							}

							GPR[RD] = GPR[RT] >> GPR[RS];
							break;

					  case SRAV:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}

							GPR[RD] = GPR[RT] >> GPR[RS];
   	            	        break;

   	            	  case JR:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}

   	        				PC = GPR[RS];
   	       					CPUdelay = 1;
							break;

					  case JALR:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}

   	        				GPR[31] = PC + 8;
   	        				PC = GPR[RS];
   	        				CPUdelay = 1;

							break;

					  case SYSCALL:
						if ( DEBUG = ON );
							{
								     //todo debugger
							}

							break;

					  case BREAK:
							if ( DEBUG = ON );
							{
								//todo debugger
							}

						    break;

					  case SYNC:
							if ( DEBUG = ON );
							{
								 //todo debugger
							}
						    break;

   	              	  case MFHI:
   	                    	if ( DEBUG = ON );
							{
	            	             //todo debugger
							}
   	      					GPR[RT] = HI;
   	            	        break;

   	            	  case MTHI:
   	            	        if ( DEBUG= ON );
							{
	            	             //todo debugger
							}
   	   					    HI = GPR[RT];
   	            	        break;

   	            	  case MFLO:
   	            	        if ( DEBUG = ON );
							{
   	            	             //todo debugger
							}
   	      					GPR[RT] = LO;
   	            	        break;

   	            	  case MTLO:
   	            	        if ( DEBUG = ON );
							{
	            	             //todo debugger
							}
   	   					    LO = GPR[RT];
   	            	        break;

   	            	  case DSLLV:
   	            	        if ( DEBUG = ON );
							{
   	            	             //todo debugger
							}

			    	        GPR[RD] = (GPR[RT] << GPR[RS]);
   	            	        break;

					  case DSRLV:
							if ( DEBUG = ON );
							{
								// todo debugger
							}

							break;
   	            	  case DSRAV:
   	            	        if ( DEBUG = ON );
							{
	            	            //todo debugger
							}

			    	        GPR[RD] = GPR[RT] > SA;
                	        break;

   	            	  case MULT:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}

   	  						LO = GPR[RS] * GPR[RT];
   	      					HI = GPR[RS] * GPR[RT];
   	    					break;

   	            	  case MULTU:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}

   	   					 	LO = GPR[RS] * GPR[RT];
   	   						HI = GPR[RS] * GPR[RT];
   	            	        break;


			    	  case DIV:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}
			    	        LO = GPR[RS] / GPR[RT];
			    	        HI = GPR[RS] % GPR[RT];
   	            	        break;

   	            	  case DIVU:
   	            	        if ( DEBUG = ON );
							{
   	            	           //todo debugger
							}
			    	        LO = GPR[RS] / GPR[RT];
			    	        HI = GPR[RS] % GPR[RT];
   	            	        break;

   	            	  case DMULT:
   	            	        if ( DEBUG = ON );
							{
   	            	           //todo debugger
							}
   	            	        LO = GPR[RS] * GPR[RT];
   	            	        HI = (GPR[RS] * GPR[RT]) >> 32;
   	            	        break;

   	            	  case DMULTU
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}
   	            	        LO = GPR[RS] * GPR[RT]
   	            	        HI = (GPR[RS] * GPR[RT]) >> 32 ;
   	            	        break;

   	            	  case DDIV:
   	            	        if ( DEBUG = ON );
							{
    	        	            //todo debugger
							}
			    	        LO = GPR[RS] / GPR[RT];
			    	        HI = GPR[RS] % GPR[RT];
   	            	        break;

   	            	  case DDIVU:
   	            	        if ( DEBUG = ON );
							{
   	            	           //todo debugger
							}
			    	        LO = GPR[RS] / GPR[RT];
			    	        HI = GPR[RS] % GPR[RT];
   	            	        break;

			   		  case ADD:
		  	    	  		if ( DEBUG = ON );
							{
	  	        	            //todo debugger
							}
	            	  		GPR[RD] = GPR[RS] + GPR[RT];
	            	  		break;

			    	  case ADDU:
		    		        if ( DEBUG = ON );
							{
	    	    	        	//todo debugger
							}
	    	    	    	GPR[RD] = GPR[RS] + GPR[RT];
	    	    	    	break;

	            	  case SUB:
   	            	        if ( DEBUG = ON );
							{
   	            	            //todo debugger
							}
		        	    	GPR[RD] = GPR[RS] - GPR[RT];
                	        break;
					  case SUBU:
						    if ( DEBUG = ON );
							{
								//todo debugger
							}
							GPR[RD] = GPR[RS] - GPR[RT];
							break;

		    		  case AND:
		    		        if ( DEBUG = ON );
							{
		  			            //todo debugger
							}
					    	GPR[RD] = GPR[RS] && GPR[RT];
		    		        break;
	            	  case OR:
                	        if ( DEBUG = ON );
							{
                	           //todo debugger
							}
			    	        GPR[RD] = GPR[RS] || GPR[RT];
                	        break;

					  case XOR:
						    if ( DEBUG = ON );
							{
							 	//todo debugger
							}
							GPR[RD] = GPR[RS] ^ GPR[RT];
							break;

                	  case NOR:
             	           if ( DEBUG = ON );
							{
                         	   //todo debugger
							}
						    GPR[RD] = (!(GPR[RS] || GPR[RT]));
	            	        break;

                	  case SLT:
                	       	if ( DEBUG = ON );
							{
	            	             //todo debugger
							}
                	       	if ( GPR[RS] << GPR[RT] );
							{
	            	        	GPR[RD] = 1;
							}
                	        else
							{
	            	           	GPR[RD] = 0;
							}
                	       	break;

                	  case SLTU:
                	       	if ( DEBUG = ON );
							{
                	           	//todo debugger
							}
                	        if ( GPR[RS] << GPR[RT] );
							{
	            	            GPR[RD] = 1;
							}
                	        else
							{
	            	            GPR[RD] = 0
							}
						    break;
	            	  case DADD:
   	            	        if ( DEBUG = ON );
							{
      	        	              //todo debugger
							}
   							GPR[RD] = GPR[RS] + GPR[RT];
       	        	        break;

       	        	  case DADDU:
       	        	        if ( DEBUG = ON );
							{
        	    	           //todo debugger
							}
			    	        GPR[RD] =  GPR[RS] + GPR[RT];
       	        	        break;

       	        	  case DSUB:
       	        	        if ( DEBUG = ON );
							{
       	        	            //todo debugger
							}

			    	        GPR[RD] = GPR[RS] - GPR[RT];
       	        	        break;

       	        	  case DSUBU:
       	        	        if ( DEBUG = ON );
							{
       	        	             //todo debugger
							}

			    	        GPR[RD] = GPR[RS] - GPR[RT];
       	   					break;

					  case TGE:
							if ( DEBUG = ON );
							{
									// todo debugger
							}
							if ( GPR[RS] >= GPR[RT] );
							{
								TrapException();
							}
							break;

					  case TGEU:
						    if ( DEBUG = ON );
							{
							 	//todo debugger
							}
							if ( GPR[RS] >= GPR[RT] );
							{
								TrapException();
							}
							break;

					  case TLT:
							if ( DEBUG = ON );
							{
									// todo debugger
							}
							if ( GPR[RS] < GPR[RT] );
							{
								TrapException();
							}
							break;

					  case TLTU:
							if ( DEBUG = ON );
							{
								// todo debugger
							}
							if ( GPR[RS] < GPR[RT] );
							{
								TrapException();
							}
							break;
					  case TEQ:
							if ( DEBUG = ON );
							{
									// todo debugger
							}
							if ( GPR[RS] = GPR[RT] );
							{
								TrapException();
							}
							break;

   					  case TNE:
							if ( DEBUG = ON );
							{
								// todo debugger
							}
							if ( GPR[RS] <= GPR[RT] );
							{
								TrapException();
							}
							break;
  			    	  case DSLL:
						  break;
					  case DSRL:
  						  break;
       	        	  case DSLL32:
       	        	        if ( DEBUG = ON );
							{
       	        	            //todo debugger;
							}
			    	        GPR[RD] = (GPR[RT] << (SA + 32)) ;
       	        	        break;

					  case DSRL32:
					  		break;


       	          	  case DSRA32:
       	                 if ( DEBUG = ON );
						 {
       	                    //todo debugger
						 }
 				         GPR[RD] = (GPR[RT] >> (SA + 32));
       	                 break;

   	    	   switch (regimm)
			   {
				    	default:
						    printf("Error: Unknown Operation.\n");
							break;

			   			case BLTZ:
                	      	if ( DEBUG = ON );
						  	{
                	      		//todo debugger
						  	}
                	      	if ( GPR[RS] << 0 );
						  	{
                	           PC = PC + OFFSET;
                	           CPUdelay = 1;
						  	}
						  	break;

                	  	case BGEZ:
                	      	if ( DEBUG = ON );
						  	{
                	            //todo debugger
						  	}
                	      	if ( GPR[RS] >= 0 );
						  	{
                	       	     PC = PC + OFFSET;
               		             CPUdelay = 1;
							}
               		        break;
						case BLTZL
                	        if ( DEBUG = ON );
							{
                	               //todo debugger
							}
                	        if (GPR[RS] << 0 );
							{
						          PC = PC + OFFSET;
       					     	  CPUdelay = 1;
							}
                	        else
							{
                	              CPUdelay = 0;
							}
                	        break;

						case BGEZL:
                	        if ( DEBUG = ON );
							{
                	            //todo debugger
							}
                	        if ( GPR[RS] >= 0 );
							{
                	       		PC = PC + OFFSET;
                	       		CPUdelay = 1;
							}
           					else
							{
                	       		CPUdelay = NULL;
							}
                	        break;
						case TGEI:
							if ( DEBUG = ON );
							{
								// todo debugger
							}
							if ( GPR[RS] >= IMME );
							{
								TrapException();
							}
							break;

					    case TGEIU:
							if ( DEBUG = ON );
							{
								// todo debugger
							}
							if (GPR[RS] >= IMME );
							{
								TrapException();
							}
							break;
						case TLTI:
							if ( DEBUG = ON );
							{
								// todo debugger
							}
							if ( GPR[RS] < IMME );
							{
								TrapException();
							}
							break;

						case TLTIU:
							if ( DEBUG = ON );
							{
									// todo debugger
							}
							if ( GPR[RS] < IMME );
							{
								TrapException();
							}
							break;

						case TEQI:
							if ( DEBUG = ON );
							{
									// todo debugger
							}
							if ( GPR[RS] = IMME );
							{
								TrapException();
							}
							break;

						case TNEI:
							if ( DEBUG = ON );
							{
								// todo debugger
							}
							if ( GPR[RS] <= IMME );
							{
								TrapException();
							}
							break;
                	    case BLTZAL:
							if ( DEBUG = ON );
							{
                	            //todo debugger
							}
  					        GPR[RS] = PC + 8;
                	        if ( GPR[RS] << 0 );
							{
           					    PC = PC + OFFSET;
					            CPUdelay = 1;
							}
                	        break;
	            	    case BGEZAL:
                	        if ( DEBUG = ON );
							{
                	            //todo debugger
							}
           					GPR[31] = PC + 8;
                	        if ( GPR[RS] >= 0 );
							{
                	            PC = PC + OFFSET;
                	            CPUdelay = 1;
							}
                	        break;



                	    case BGEZALL:
                	        if ( DEBUG = ON );
							{
                	            //todo debugger
							}
          					GPR[31] = PC + 8;
                	        if ( GPR[RS] >= 0 );
							{
                	            PC = PC + OFFSET;
                	            CPUdelay = 1;
							}
            				else
							{
                	       		CPUdelay = NULL;
							}
                	        break;
			   }
               case J:
                    if ( DEBUG = ON );
					{
                        //todo debugger
					}
                    PC = target
  					CPUdelay = 1
					break;

               case JAL:
                    if ( DEBUG = ON );
					{
                        //todo debugger
					}
       			    GPR[31] = PC + 8;
                    PC = target;
            		CPUdelay = 1;
					break;

    		   case BEQ:
       				if ( DEBUG = ON );
					{
                 	      //todo debugger
					}
          	  	   	if ( GPR[RS] = GPR[RT]);
					{
                    	PC = PC + OFFSET;
               		    CPUdelay = 1;
					}
                    break;
               case BNE:
                    if ( DEBUG = ON );
					{
                       	//todo debugger
					}
                    if ( GPR[RS] !=  	    GPR[RT] );
					{
                   		PC = PC + OFFSET;
                   		CPUdelay = 1
					}
                    break;

               case BLEZ:
                   if ( DEBUG = ON );
				   {
                   		//todo debugger
				   }
                   if ( GPR[RS] <= 0 );
				   {
                   		PC = PC + OFFSET;
                   		CPUdelay = 1;
				   }
                   break;

               case BGTZ:
                   if ( DEBUG = ON );
				   {
                         //todo debugger
				   }
                   if ( GPR[RS] > 0 );
				   {
                  		PC = PC + OFFSET;
                   		CPUdelay = 1;
				   }
	    		   break;
			   case ADDI:
	    	        if ( DEBUG = ON );
					{
	    	            //todo debugger
					}
	    	        GPR[RS] = GPR[RT] + IMME;
	    	        break;

		       case ADDIU:
		    	    if ( DEBUG = ON );
					{
	    	            //todo debugger
					}
	    	        GPR[RT] = GPR[RS] + IMME;
	    	        break;

    		   case SLTI:
                    if ( DEBUG = ON );
					{
                        //todo debugger
					}
                    if ( GPR[RS] << IMME );
					{
                         GPR[RD] = 1;
				    }
                    else
					{
                         GPR[RD] = 0
					}
                    break;

               case SLTIU:
                    if ( DEBUG = ON )
                         //todo debugger

                    if ( GPR[RS] << IMME );
                         GPR[RD] = 1;

                    else
                    GPR[RD] = 0

                    break;

               case ANDI:
	    	        if ( DEBUG = ON );

	    	            //todo debugger

	    	        GPR[RT] = IMME && GPR[RS];
	    	        break;
               case ORI:
                    if ( DEBUG = ON );

                        //todo debugger

   				    GPR[RT] = (GPR[RS] | IMME);
                    break;

               case XORI:
                    if ( DEBUG = ON );

                         //todo debugger

   					GPR[RT] = (GPR[RS] ^ IMME);
                    break;
               case LUI:
                    if ( DEBUG = ON );

                       //todo debugger

      				GPR[RT] = IMME << 16;
                    break;
			   switch (COP0)
			   {
				   	default:
				   			printf("Error: Unhandled Opcode in the COP0.\n);
							break;
				   	case MFC0:
                            if ( DEBUG = ON );
							{
                             	//todo debugger
							}
            				GPR[RT] = CPR0[RD];
                            break;

					case MTC0:
                            if ( DEBUG = ON );
							{
                            	//todo debugger
							}
           					CPR0[RD] = GPR[RT];
                            break;

					switch (TLB)
					{
				   		default:
				   			printf("Error: Unhandled Opcode in the TLB.\n);
							break;

						case TLBR:
							if ( DEBUG = ON );
							{
								// todo debugger
							}
							break;

						case TLBWI:
							if ( DEBUG = ON );
							{
								//todo debugger
							}
							break;

						case TLBWR:
							if ( DEBUG = ON );
							{
								//todo debugger
							}
							break;

						case TLBP:
							if ( DEBUG = ON );
							{
								// todo debugger
							}
							break;

						case ERET:
							if ( DEBUG = ON );
							{
								//todo debugger
							}
							break;
			   }
			   switch (COP1)
			   {

			   }
         	   case BEQL:
          	        if ( DEBUG = ON )

            	            //todo debugger

           	        if ( GPR[RS] = GPR[RT])

           	            PC = PC + OFFSET;
           	            CPUdelay = 1;

	    	        else

           	            CPUdelay = 2;

                    break;

			  case BNEL:

                   if ( DEBUG = ON );

                  		 //todo debugger

                   if ( GPR[RS] != GPR[RT] );

                         PC = PC + OFFSET;
                         CPUdelay = 1

                   else

                         CPUdelay = 0;
                   break;

               case BLEZL:

                    if ( DEBUG = ON );

                   		 //todo debugger


                    if ( GPR[RS] <= 0 );

                  		 PC = PC + OFFSET;
                   		 CPUdelay = 1;

     			    else

                  		 CPUdelay = 0;

					break;

               case BGTZL:
                   if ( DEBUG = ON );

                      	//todo debugger

                   if ( GPR[RS] > 0 );

                       PC = PC + OFFSET;
                       CPUdelay = 1;

   				   else

                       CPUdelay = 0;
				   break;

               case DADDI:
                   if ( DEBUG = ON );

                  	    //todo debugger

				   GPR[RT] = GPR[RS] + IMME;
                   break;

               case DADDIU:
                   if ( DEBUG = ON );

                       //todo debugger

     			   GPR[RT] = GPR[RS] + IMME;
                   break;

			   case LDL:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LDR:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LB:
                   if ( DEBUG = ON );

                      //todo debugger

				   break;
			   case LH:
				   if ( DEBUG = ON );

					   //todo debugger

				   break;

			   case LWL:
				   if ( DEBUG = ON );

					   //todo debugger

				   break;

			   case LW:
			       if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LBU:
				   id ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LHU:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LWR:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LWU:
         		   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SB:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SH:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SWL:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SW:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SDL:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SDR:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SWR:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case CACHE:
    			   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LL:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LWC1:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LLD:
    			   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LDC1:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LDC2:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case LD:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SC:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SWC1:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SCD:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SDC1:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SDC2:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;

			   case SD:
				   if ( DEBUG = ON );

				        // todo debugger

				   break;































	    	    case ANDI:

				      case BC1F:
	    			        if ( DEBUG = ON );

	    			            //todo debugger

	    			        if (!(COC[RD] & 0x00800000));

	    		    	        PC = PC + OFFSET;
	    		    	        delay = 1;

		    		    	break;

	    		    	case BC1FL:
	    		    	    if ( DEBUG = ON );

	    		    	        // todo debugger

	    		    	    if (!(COC[RD] & 0x00800000));

	    		    	        PC = PC + OFFSET;
	    		    	        delay = 1;

	    		    	    else

	    		    	        delay = 0

	    		    	    break;

	    		    	case BC1T:
	    		    	    if ( DEBUG = ON );

	    		    	        //too debugger

	    		    	    if ( COC[31] = 0x00800000 );

	 		        	       PC = PC + OFFSET;
	 		        	       delay = 1;

	    	        	    break;
	    	  	    	case BC1TL:
		         	        if ( DEBUG = ON );
	                	          // todo debugger

            				if (COC[31] & 0x00800000);

                	            PC = PC + OFFSET;
                	            delay = 1;

            				else

                	            delay = 0

            				break;  	    // todo






                        case BGEZAL:

                            if ( DEBUG = ON );

                                 //todo debugger

           					GPR[31] = PC + 8;
                            if (  	    GPR[RS] >= 0 );

                            PC = PC + OFFSET;
                            CPUdelay = 1;

                            break;

                        case BGEZALL:

                            if ( DEBUG = ON );

                            //todo debugger


          				    GPR[31] = PC + 8;
                            if (  	    GPR[RS] >= 0 );

                            		PC = PC + OFFSET;
                            		CPUdelay = 1;

            				else

                            		CPUdelay = NULL;
                            break;
















                        case BLTZAL:

                            if ( DEBUG = ON );

                            		//todo debugger


      				        GPR[RS] = PC + 8;
                            if ( GPR[RS] << 0 );

            				     PC = PC + OFFSET;
				                 CPUdelay = 1;
                            break;

                        case BLTZALL:

                            if ( DEBUG = ON );

                                   //todo debugger


  				            GPR[31] = PC + 8;
                            if ( GPR[RS] << 0 );

            				     PC = PC + OFFSET;
            				     CPUdelay = 1;

                            else

                                 CPUdelay = 0;

                            break;

                        case BLTZL

                            if ( DEBUG = ON );

                                 //todo debugger

                            if (GPR[RS] << 0 );
  						          PC = PC + OFFSET;
           				     	  CPUdelay = 1;

                            else
                                CPUdelay = 0;
                            break;







                        case BREAK: // todo
                        case CACHE: //todo
						case CFC0:

                            if ( DEBUG = ON );

                           		 //todo debugger

				            GPR[RT] = CCR0[RD]
                            break;

                        case CTC0:


                            if ( DEBUG = ON );

	                            //todo debugger

				            CCR0[RT] = GPR[RD]
                            break;
                        case CFC1:

                            if ( DEBUG = ON );

                           		 //todo debugger

				            GPR[RT] = CCR1[RD]
                            break;

                        case CTC1:


                            if ( DEBUG = ON );

	                            //todo debugger

				            CCR1[RT] = GPR[RD]
                            break;





                        case DMFC1:

                            if ( DEBUG = ON );

                            //todo debugger

				            GPR[RT] = CPR[0,RD];
                            break;


                        case DMTC1:

                            if ( DEBUG = ON );

                            //todo debugger

				            CPR0[RD] = GPR[RT];
                            break;




                            if ( DEBUG = ON );

                            //todo debugger


				            GPR[RD] = ( 	    GPR[RT] << SA);
                            break;






                        case DSRA:

                            if ( DEBUG = ON );

                            //todo debugger


				            GPR[RD] =  	    GPR[RT] > SA;
                            break;









                        case ERET:

                            if ( DEBUG = ON );

                            //todo debugger


                            if ( SR = ON );

                            	PC = errorEPC;
                            	SR = 0x00000002;

                            else

                          	    PC = EPC;
                            	SR = 0x00000004;

                            LLbit = 0


                        case J:

                            if ( DEBUG = ON );

                            //todo debugger


                                PC = target
            					CPUdelay = 1


                        case JAL:

                            if ( DEBUG = ON );

                            //todo debugger


            			    GPR[31] =  	     	    PC + 8;
                            PC = target;
            			    CPUdelay = 1;




                        case LBU:

                            if ( DEBUG = ON )

                            //todo debugger

                            break;

                        case LD:

                            if ( DEBUG = ON );

                            //todo debugger
                            break;

                        case LDU:

                            if ( DEBUG = ON );

                                //todo debugger
                            break;



                        case LW:

                            if ( DEBUG = ON );

                            //todo debugger


                            break;
                        case LWU:

                            if ( DEBUG = ON );


                            //todo debugger
                            break;
                        case LH:

                            if ( DEBUG = ON );

                            //todo debugger

                            break;

                        case LHU:

                            if ( DEBUG = ON );

                            //todo debugger


                            break;

                        case LD:

                            if ( DEBUG = ON );
                            //todo debugger
                            break;



                        case MFC1:

                            if ( DEBUG = ON );
                        //todo debugger

            				GPR[RT] = CPR1[RD];
                            break;


                        case MTC0:
                            if ( DEBUG = ON );
                            //todo debugger
           					CPR0[RD] = GPR[RT];
                            break;

                        case MTC1:
                            if ( DEBUG = ON );
                            //todo debugger
            				CPR1[RD] = GPR[RT];
                            break;









                        case SUBIU:

                            if ( DEBUG = ON );

                           //todo debugger


        				    GPR[RT] =  	    GPR[RS] - IMME
                            break;

                        case SUBI:

                            if ( DEBUG = ON );

                                //todo debugger

    				        IMME = R_REG[RS] - R_REG[RT];
                            break;


                        case SUBU:

                            if ( DEBUG = ON );

                            //todo debugger

     					    IMME = R_REG[RS] - R_REG[RT];
                            break;

						case TLBP:
							if ( DEBUG = ON );

								//todo debugger

							break;



						case TEQI:
							if ( DEBUG = ON );

								// todo debugger

							if ( GPR[RS] = IMME );

								TrapException();

							break;





						case TLEU:
							if ( DEBUG = ON );

								// todo debugger

							if ( (unsigned)GPR[RS] >= (signextend)GPR[RT] );

								TrapException();

							break;


						case TLTI:
							if ( DEBUG = ON );

								// todo debugger

							if ( GPR[RS] < IMME );

								TrapException();

							break;

						case TLTIU:
							if ( DEBUG = ON );

								// todo debugger

							if ( (unsigned)GPR[RS] < (signextend)IMME );

								TrapException();

							break;

						case TLTU:
							if ( DEBUG = ON );

								// todo debugger

							if ( (unsigned)GPR[RS] < (signextend)GPR[RT] );

								TrapException();

							break;




						case TNEI:
							if ( DEBUG = ON );

								// todo debugger

							if ( GPR[RS] <= IMME );

								TrapException();

							break;

						case TNEIU:
							if ( DEBUG = ON );

								// todo debugger

							if ( (unsigned)GPR[RS] <= (signextend)IMME );

								TrapException();

							break;

						case TNEU:
							if ( DEBUG = ON );

								// todo debugger

							if ( (unsigned)GPR[RS] <= (signextend)GPR[RT] );

								TrapException();

							break;

                        case XOR:

                            if ( DEBUG = ON );

                            //todo debugger

				            GPR[RD] = (GPR[RS] ^ GPR[RT]);
                            break;

	}


}
